TACHYON

{ PING.fth - PING))) ultrasonic range finder unit

  UPDATED:  120818.1800 - bBR - complete overhaul
  CREATED:  120817.1500 - Brian Riley - Underhill Center, VT, USA
  BASEDON:  060508.0000 - Chris Savage/Jeff Martin, - Parallax

 - pin 5 to SIG on prop with 1K resistor
 - prop pins should be edited to your needs

    PING)))™ Ultrasonic Distance Sensor (#28015)

		┌───────────────────┐
		│┌───┐         ┌───┐│ Connection To Propeller
		││ ‣ │ PING))) │ ‣ ││ Remember PING))) Requires
		│└───┘         └───┘│ +5V Power Supply
		│    GND +5V SIG    │
		└─────┬───┬───┬─────┘
		      │  │    1K
		        └┘   └ Pin
		
		
 - Prop pin is fed in on the stack, it is MASKed for use by OUTxxx, IN, WAITPxx, etc

 - The pinmask value on the top of the stack is DUPed before each I/O  to preserve it

 - The OUTxxx words set pin for output themselves, WAITPxx do not and require the INPUTS

 - NEWCNT places current value of CNT on the top of the loop stack

 - LAPCNT returns via the normal stack, the number of usecs since the NEWCNT was issued. 
   LAPCNT takes its name because the running CNT time can continued to be checked until
   a new NEWCNT is issued

 - *** NOTA BENE *** If you specify the wrong pin for the ping connection to the Prop
   the code  will hangup _HARD_ at the WAITPEQ. If so I hope you have a working
    RESET button!

}

       \ conversion constants for room temperature
       \ for temperature compensation see Ping Manual

#73_746 CONSTANT toinches

#29_034 CONSTANT tocms


: PTICKS ( pin -- usecs )

         MASK
         DUP OUTCLR 1 ms      \ clear signal pin

         DUP OUTSET 3 us      \ send >2 us pulse
         DUP OUTCLR

         DUP INPUTS		 	  \ turn pin around to listen

         DUP WAITPEQ          \ await PING sets line HIGH
         NEWCNT				  \ store cnt

         WAITPNE              \ await PING sets line LOW
		 LAPCNT               \ returns usecs since NEWCNT
         ;

\ ***************************************************************

: PINGMM ( pin -- distmm )
         PTICKS 
         #10_000 * tocms /    \ convert usecs to millimeters
         ;

: PINGCM ( pin -- distcm )
         PINGMM 10 /           \ convert millimeters to centimeters
         ;

: PINGIN ( pin -- distin )
         PTICKS 
         #1_000 * toinches /    \ convert usecs to inches
         ;






z

END
